src/main/java/com/max/pedidovenda/model/Produto.java
package com.max.pedidovenda.model;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import com.max.pedidovenda.validation.SKU;

@Entity
@Table(name = "produto")
public class Produto implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@NotBlank
	@Size(max = 80)
	@Column(nullable = false, length = 80)
	private String nome;

	@NotBlank
	@SKU
	@Column(nullable = false, length = 100)
	private String sku;

	@NotNull
	@Column(name = "valor_unitario", nullable = false, precision = 10, scale = 2)
	private BigDecimal valorUnitario;

	@NotNull
	@Min(0)
	@Max(value = 9999, message = "tem um valor muito alto")
	@Column(name = "quantidade_estoque", nullable = false, length = 5)
	private Integer quantidadeEstoque;

	@NotNull
	@ManyToOne
	@JoinColumn(name = "categoria_id", nullable = false)
	private Categoria categoria;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getSku() {
		return sku;
	}

	public void setSku(String sku) {
		this.sku = sku;
	}

	public BigDecimal getValorUnitario() {
		return valorUnitario;
	}

	public void setValorUnitario(BigDecimal valorUnitario) {
		this.valorUnitario = valorUnitario;
	}

	public Integer getQuantidadeEstoque() {
		return quantidadeEstoque;
	}

	public void setQuantidadeEstoque(Integer quantidadeEstoque) {
		this.quantidadeEstoque = quantidadeEstoque;
	}

	public Categoria getCategoria() {
		return categoria;
	}

	public void setCategoria(Categoria categoria) {
		this.categoria = categoria;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Produto other = (Produto) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

}

src/main/java/com/max/pedidovenda/controller/CadastroProdutoBean.java
package com.max.pedidovenda.controller;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;

import com.max.pedidovenda.model.Categoria;
import com.max.pedidovenda.model.Produto;
import com.max.pedidovenda.repository.CategoriaRepository;
import com.max.pedidovenda.service.CadastroProdutoService;
import com.max.pedidovenda.util.jsf.FacesUtil;

@Named
@ViewScoped
public class CadastroProdutoBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private Produto produto = new Produto();
	private Categoria categoria = new Categoria();
	private List<Categoria> categorias = new ArrayList<>();
	private List<Categoria> subCategorias = new ArrayList<>();

	@Inject
	private CategoriaRepository categoriasRepository;
	@Inject
	private CadastroProdutoService cadastroProdutoService;

	public CadastroProdutoBean() {
		this.limpar();
	}

	public void inicializar() {
		if (FacesUtil.isNotPostback()) {
			this.categorias = this.categoriasRepository.buscar();
		}
	}

	public void salvar() {
		this.produto = this.cadastroProdutoService.salvar(this.produto);
		this.limpar();
		FacesUtil.addInfoMessage("Produto salvo com sucesso!");
	}

	public void carregarSubcategoria() {
		this.subCategorias = this.categoriasRepository.buscarSubcategoria(this.categoria);
	}

	private void limpar() {
		this.produto = new Produto();
		this.categoria = new Categoria();
		this.subCategorias = new ArrayList<>();
	}

	public Produto getProduto() {
		return produto;
	}

	public void setProduto(Produto produto) {
		this.produto = produto;
	}

	public List<Categoria> getCategorias() {
		return categorias;
	}

	public Categoria getCategoria() {
		return categoria;
	}

	public void setCategoria(Categoria categoria) {
		this.categoria = categoria;
	}

	public List<Categoria> getSubCategorias() {
		return subCategorias;
	}

}

src/main/java/com/max/pedidovenda/controller/PesquisaProdutoBean.java
package com.max.pedidovenda.controller;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.faces.view.ViewScoped;
import javax.inject.Named;

@Named
@ViewScoped
public class PesquisaProdutoBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private List<Integer> pedidosFiltrados = new ArrayList<>();

	public PesquisaProdutoBean() {
		this.pedidosFiltrados = new ArrayList<>();
		for (int i = 0; i < 50; i++) {
			this.pedidosFiltrados.add(i);
		}
	}

	public List<Integer> getProdutosFiltrados() {
		return pedidosFiltrados;
	}

}

src/main/webapp/produtos/CadastroProduto.xhtml
<ui:composition template="/WEB-INF/template/LayoutPadrao.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui" xmlns:o="http://omnifaces.org/ui">

	<ui:define name="titulo">Novo produto</ui:define>


	<ui:define name="corpo">

		<f:metadata>
			<f:viewParam name="dummy" />
			<f:event listener="#{cadastroProdutoBean.inicializar}"
				type="preRenderView" />
		</f:metadata>


		<h:form>
			<h1>Novo produto</h1>

			<p:messages autoUpdate="true" closable="true" showDetail="true">
				<p:effect type="pulsate" event="load" delay="500" />
			</p:messages>
			<p:growl life="4000" autoUpdate="true" />

			<p:toolbar style="margin-top: 20px;">
				<p:toolbarGroup>
					<p:button value="Novo" outcome="/produtos/CadastroProduto" />
					<p:commandButton value="Salvar" id="botaoSalvar"
						actionListener="#{cadastroProdutoBean.salvar}" update="@form" />
				</p:toolbarGroup>
				<p:toolbarGroup align="right">
					<p:button value="Pesquisa" outcome="/produtos/PesquisaProduto" />
				</p:toolbarGroup>
			</p:toolbar>

			<p:panelGrid columns="2" id="painel"
				style="width: 100%; margin-top: 20px;" columnClasses="rotulo campo">
				<p:outputLabel value="SKU" for="sku" />
				<p:inputText id="sku" size="20" maxlength="20"
					value="#{cadastroProdutoBean.produto.sku}" />

				<p:outputLabel value="Nome" for="nome" />
				<p:inputText id="nome" size="60" maxlength="80"
					value="#{cadastroProdutoBean.produto.nome}" />

				<p:outputLabel value="Categoria" for="categoria" />
				<p:selectOneMenu id="categoria"
					value="#{cadastroProdutoBean.categoria}">
					<f:selectItem itemLabel="Selecione a categoria" />
					<f:selectItems value="#{cadastroProdutoBean.categorias}"
						var="categoria" itemLabel="#{categoria.descricao}"
						itemValue="#{categoria}" />
					<f:ajax listener="#{cadastroProdutoBean.carregarSubcategoria}"
						render="subcategoria" />
				</p:selectOneMenu>

				<p:outputLabel value="Subcategoria" for="subcategoria" />
				<p:selectOneMenu id="subcategoria"
					value="#{cadastroProdutoBean.produto.categoria}">
					<f:selectItem itemLabel="Selecione a subcategoria" />
					<f:selectItems value="#{cadastroProdutoBean.subCategorias}"
						var="subCategoria" itemLabel="#{subCategoria.descricao}"
						itemValue="#{subCategoria}" />
				</p:selectOneMenu>

				<p:outputLabel value="Valor unitário" for="valorUnitario" />
				<p:inputText id="valorUnitario" size="10" maxlength="10"
					styleClass="moeda"
					value="#{cadastroProdutoBean.produto.valorUnitario}">
					<f:convertNumber maxFractionDigits="2" minFractionDigits="2" />
				</p:inputText>

				<p:outputLabel value="Estoque" for="estoque" />
				<p:inputText id="estoque" size="10" maxlength="4"
					value="#{cadastroProdutoBean.produto.quantidadeEstoque}" />
			</p:panelGrid>
		</h:form>
	</ui:define>
</ui:composition>

src/main/webapp/produtos/PesquisaProduto.xhtml
<ui:composition template="/WEB-INF/template/LayoutPadrao.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui" xmlns:o="http://omnifaces.org/ui">

	<ui:define name="titulo">Pesquisa produto</ui:define>


	<ui:define name="corpo">
		<h:form>
			<h1>Pesquisa produto</h1>

			<p:toolbar style="margin-top: 20px;">
				<p:toolbarGroup>
					<p:commandButton value="Pesquisar" />
				</p:toolbarGroup>
				<p:toolbarGroup align="right">
					<p:button value="Novo" outcome="/produtos/CadastroProduto" />
				</p:toolbarGroup>
			</p:toolbar>

			<p:panelGrid columns="2" id="painel"
				style="width: 100%; margin-top: 20px;" columnClasses="rotulo campo">
				<p:outputLabel value="SKU" for="sku" />
				<p:inputText id="sku" size="20" />

				<p:outputLabel value="Nome" for="nome" />
				<p:inputText id="nome" size="60" />
			</p:panelGrid>

			<p:dataTable id="produtosTable"
				value="#{pesquisaProdutoBean.produtosFiltrados}" var="produto"
				style="margin-top: 20px;" emptyMessage="Nenhum produto encontrado."
				rows="20" paginator="true" paginatorAlwaysVisible="false"
				paginatorPosition="bottom">

				<p:column headerText="SKU" style="text-align: center; width: 100px;">
					<h:outputText value="123" />
				</p:column>

				<p:column headerText="Nome">
					<h:outputText value="Bala de morango" />
				</p:column>

				<p:column headerText="Categoria" style="width: 250px">
					<h:outputText value="Doces - Balas e chicletes" />
				</p:column>

				<p:column headerText="Valor unitário"
					style="text-align: right; width: 120px;">
					<h:outputText value="R$ 1,20" />
				</p:column>

				<p:column headerText="Estoque"
					style="text-align: center; width: 100px;">
					<h:outputText value="98" />
				</p:column>

				<p:column style="width: 100px; text-align: center;">
					<p:button icon="ui-icon-pencil" title="Editar" />
					<p:commandButton icon="ui-icon-trash" title="Excluir">
						<p:confirm header="Exclusão de produto"
							message="Tem certeza que deseja excluir o produto?"
							icon="ui-icon-alert" />
					</p:commandButton>
				</p:column>
			</p:dataTable>

			<p:confirmDialog global="true" showEffect="fade" hideEffect="fade">
				<p:commandButton value="Sim" type="button"
					styleClass="ui-confirmdialog-yes" icon="ui-icon-check" />
				<p:commandButton value="Não" type="button"
					styleClass="ui-confirmdialog-no" icon="ui-icon-close" />
			</p:confirmDialog>

		</h:form>
	</ui:define>
</ui:composition>